<template>
    <g :transform="position">
        <g :transform="transform">
            <rect x="-5" y="5" width="10" :height="height" stroke="black" fill="white" />
            <self-item
                v-if="level > 1"
                :level="level - 1"
                :option="weakenOption"
                :height="height"
            />
        </g>
    </g>
</template>

<script>
/* eslint-disable no-param-reassign */
// @ is an alias to /src
// import gsap from 'gsap'
import _ from 'lodash'
import gsap from 'gsap'

export default {
    name: 'SelfItem',
    props: {
        level: {
            type: Number,
            default: undefined,
        },
        height: {
            type: Number,
            default: undefined,
        },
        option: {
            type: Object,
            default: null,
        },
    },
    data() {
        const timeline = gsap.timeline({
            autoRemoveChildren: true,
            smoothChildTiming: true,
            onComplete() {
                if (this.timeScale() !== 1) {
                    this.timeScale(1)
                }
            },
        })
        return {
            self_option: { rotate: 0 },
            timeline,
        }
    },
    computed: {
        position() {
            return `translate(-0 ${this.height})`
        },
        transform() {
            if (this.self_option) {
                return `rotate(${this.self_option.rotate})`
            }
            return 'rotate(0)'
        },
        weakenOption() {
            if (this.option) {
                return _.transform(this.option, (result, value, key) => {
                    if (key === 'delay') {
                        result[key] = value + 0.1
                    } else if (key === 'duration') {
                        if (value > 0.5) {
                            result[key] = gsap.utils.snap(0.01, value * 0.5)
                        } else if (value < 0.5 && value > 0.01) {
                            result[key] = gsap.utils.snap(0.01, value * 0.9)
                        } else {
                            result[key] = gsap.utils.snap(0.01, value)
                        }
                    } else if (typeof value === 'number') {
                        result[key] = gsap.utils.snap(0.01, value * 0.9)
                    } else {
                        result[key] = value
                    }
                }, {})
            }
            return {}
        },
    },
    watch: {
        option() {
            this.move()
        },
    },
    mounted() {
        // this.self_option = this.option
        this.move()
    },
    methods: {
        move() {
            if (this.timeline) {
                this.timeline.to(this.self_option, this.option)
                const { length } = this.timeline.getChildren()
                if (length > 1) {
                    this.timeline.timeScale(length)
                }
            }
        },
        complete() {
        },
    },
}
</script>
<style lang="scss">
</style>